
;CodeVisionAVR C Compiler V1.25.9 Professional
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 12,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "3dtest.vec"
	.INCLUDE "3dtest.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.9 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 28.03.2014
;      11 Author  : F4CG
;      12 Company : F4CG
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATmega16
;      17 Program type        : Application
;      18 Clock frequency     : 12,000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 256
;      22 *****************************************************/
;      23 
;      24 #include <mega16.h>
;      25 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      26 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      27 	.EQU __se_bit=0x40
	.EQU __se_bit=0x40
;      28 	.EQU __sm_mask=0xB0
	.EQU __sm_mask=0xB0
;      29 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      30 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      31 	.EQU __sm_standby=0xA0
	.EQU __sm_standby=0xA0
;      32 	.EQU __sm_ext_standby=0xB0
	.EQU __sm_ext_standby=0xB0
;      33 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      34 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      35 	#endif
	#endif
;      36 #include <delay.h>
;      37 
;      38 #define RXB8 1
;      39 #define TXB8 0
;      40 #define UPE 2
;      41 #define OVR 3
;      42 #define FE 4
;      43 #define UDRE 5
;      44 #define RXC 7
;      45 
;      46 #define FRAMING_ERROR (1<<FE)
;      47 #define PARITY_ERROR (1<<UPE)
;      48 #define DATA_OVERRUN (1<<OVR)
;      49 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      50 #define RX_COMPLETE (1<<RXC)
;      51 
;      52 // USART Receiver buffer
;      53 #define RX_BUFFER_SIZE 2
;      54 unsigned char rx_buffer[RX_BUFFER_SIZE];
_rx_buffer:
	.BYTE 0x2
;      55 
;      56 #if RX_BUFFER_SIZE<256
;      57 unsigned char rx_wr_index,rx_rd_index,rx_counter;
;      58 #else
;      59 unsigned int rx_wr_index,rx_rd_index,rx_counter;
;      60 #endif
;      61 
;      62 // This flag is set on USART Receiver buffer overflow
;      63 bit rx_buffer_overflow;
;      64 
;      65 // USART Receiver interrupt service routine
;      66 interrupt [USART_RXC] void usart_rx_isr(void)
;      67 {

	.CSEG
_usart_rx_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      68 unsigned char status,data;
;      69 status=UCSRA;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
;      70 data=UDR;
	IN   R16,12
;      71 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;      72    {
;      73    rx_buffer[rx_wr_index]=data;
	MOV  R30,R5
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	ST   Z,R16
;      74    if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
	INC  R5
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x4
	CLR  R5
;      75    if (++rx_counter == RX_BUFFER_SIZE)
_0x4:
	INC  R7
	LDI  R30,LOW(2)
	CP   R30,R7
	BRNE _0x5
;      76       {
;      77       rx_counter=0;
	CLR  R7
;      78       rx_buffer_overflow=1;
	SET
	BLD  R2,0
;      79       };
_0x5:
;      80    };
_0x3:
;      81 }
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;      82 
;      83 void putchar1(unsigned char c){
_putchar1:
;      84   //while ((UCSRA & DATA_REGISTER_EMPTY)==0);
;      85   while(!(UCSRA & (1<<UDRE)));
;	c -> Y+0
_0x6:
	SBIS 0xB,5
	RJMP _0x6
;      86   UDR=c;
	LD   R30,Y
	OUT  0xC,R30
;      87 }
	ADIW R28,1
	RET
;      88 
;      89 #ifndef _DEBUG_TERMINAL_IO_
;      90 // Get a character from the USART Receiver buffer
;      91 #define _ALTERNATE_GETCHAR_
;      92 #pragma used+
;      93 unsigned char getchar(void)
;      94 {
_getchar:
;      95 unsigned char data;
;      96 while (rx_counter==0);
	ST   -Y,R17
;	data -> R17
_0x9:
	TST  R7
	BREQ _0x9
;      97 data=rx_buffer[rx_rd_index];
	MOV  R30,R4
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	LD   R17,Z
;      98 if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
	INC  R4
	LDI  R30,LOW(2)
	CP   R30,R4
	BRNE _0xC
	CLR  R4
;      99 #asm("cli")
_0xC:
	cli
;     100 --rx_counter;
	DEC  R7
;     101 #asm("sei")
	sei
;     102 return data;
	MOV  R30,R17
	LD   R17,Y+
	RET
;     103 }
;     104 #pragma used-
;     105 #endif
;     106 
;     107 // Standard Input/Output functions
;     108 #include <stdio.h>
;     109 
;     110 // Declare your global variables here
;     111 
;     112 unsigned char command=0;// 
;     113 unsigned char engine=0;//  
;     114 
;     115 unsigned char keys=0;//
;     116 unsigned char keys0=0;//
;     117 
;     118 unsigned char encode=0;// 
;     119 unsigned char encode0=0;//
;     120 unsigned char encodeOld=0;//    
;     121 unsigned char direction=0;//    

	.DSEG
_direction:
	.BYTE 0x1
;     122 
;     123 unsigned char mode=0;//0- /   - 1
_mode:
	.BYTE 0x1
;     124 
;     125 //unsigned char command_table[27]={0b00000000,0b0000000l,0b00000010,0b00000100,0b0000010l,0b00000110,0b00001000,0b0000100l,0b00001010,0b00010000,0b0001000l,0b00010010,0b00010100,0b0001010l,0b00010110,0b00011000,0b0001100l,0b00011010,0b00100000,0b0010000l,0b00100010,0b00100100,0b0010010l,0b00100110,0b00101000,0b0010100l,0b00101010};
;     126 unsigned char command_table[27]={0x00,0x01,0x02,0x04,0x05,0x06,0x08,0x09,0x0a,0x10,0x11,0x12,0x14,0x15,0x16,0x18,0x19,0x1a,0x20,0x21,0x22,0x24,0x25,0x26,0x28,0x29,0x2a};
_command_table:
	.BYTE 0x1B
;     127 unsigned char validCommand(unsigned char c){

	.CSEG
_validCommand:
;     128         int i;
;     129         for(i=0;i<27;i++){
	ST   -Y,R17
	ST   -Y,R16
;	c -> Y+2
;	i -> R16,R17
	__GETWRN 16,17,0
_0xF:
	__CPWRN 16,17,27
	BRGE _0x10
;     130                 if(c==command_table[i]){return command_table[i];}
	LDI  R26,LOW(_command_table)
	LDI  R27,HIGH(_command_table)
	ADD  R26,R16
	ADC  R27,R17
	LD   R30,X
	LDD  R26,Y+2
	CP   R30,R26
	BRNE _0x11
	LDI  R26,LOW(_command_table)
	LDI  R27,HIGH(_command_table)
	ADD  R26,R16
	ADC  R27,R17
	LD   R30,X
	RJMP _0xE6
;     131         }
_0x11:
	__ADDWRN 16,17,1
	RJMP _0xF
_0x10:
;     132         return 255;
	LDI  R30,LOW(255)
_0xE6:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,3
	RET
;     133 }
;     134 
;     135 void main(void)
;     136 {
_main:
;     137 // Declare your local variables here
;     138 
;     139 // Reset Source checking
;     140 if (MCUCSR & 1)
	IN   R30,0x34
	SBRC R30,0
;     141    {
;     142    // Power-on Reset
;     143    MCUCSR&=0xE0;
	RJMP _0xE7
;     144    // Place your code here
;     145 
;     146    }
;     147 else if (MCUCSR & 2)
	IN   R30,0x34
	SBRC R30,1
;     148    {
;     149    // External Reset
;     150    MCUCSR&=0xE0;
	RJMP _0xE7
;     151    // Place your code here
;     152 
;     153    }
;     154 else if (MCUCSR & 4)
	IN   R30,0x34
	SBRC R30,2
;     155    {
;     156    // Brown-Out Reset
;     157    MCUCSR&=0xE0;
	RJMP _0xE7
;     158    // Place your code here
;     159 
;     160    }
;     161 else if (MCUCSR & 8)
	IN   R30,0x34
	SBRC R30,3
;     162    {
;     163    // Watchdog Reset
;     164    MCUCSR&=0xE0;
	RJMP _0xE7
;     165    // Place your code here
;     166 
;     167    }
;     168 else if (MCUCSR & 0x10)
	IN   R30,0x34
	SBRS R30,4
	RJMP _0x1A
;     169    {
;     170    // JTAG Reset
;     171    MCUCSR&=0xE0;
_0xE7:
	IN   R30,0x34
	ANDI R30,LOW(0xE0)
	OUT  0x34,R30
;     172    // Place your code here
;     173 
;     174    };
_0x1A:
;     175 
;     176 // Input/Output Ports initialization
;     177 // Port A initialization
;     178 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     179 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     180 PORTA=0xff;
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     181 DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;     182 
;     183 // Port B initialization
;     184 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     185 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     186 PORTB=0x00;
	OUT  0x18,R30
;     187 DDRB=0xff;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     188 
;     189 // Port C initialization
;     190 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     191 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     192 PORTC=0xff;
	OUT  0x15,R30
;     193 DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
;     194 
;     195 // Port D initialization
;     196 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     197 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     198 PORTD=0x00;
	OUT  0x12,R30
;     199 DDRD=0x00;
	OUT  0x11,R30
;     200 
;     201 // Timer/Counter 0 initialization
;     202 // Clock source: System Clock
;     203 // Clock value: Timer 0 Stopped
;     204 // Mode: Normal top=FFh
;     205 // OC0 output: Disconnected
;     206 TCCR0=0x00;
	OUT  0x33,R30
;     207 TCNT0=0x00;
	OUT  0x32,R30
;     208 OCR0=0x00;
	OUT  0x3C,R30
;     209 
;     210 // Timer/Counter 1 initialization
;     211 // Clock source: System Clock
;     212 // Clock value: Timer 1 Stopped
;     213 // Mode: Normal top=FFFFh
;     214 // OC1A output: Discon.
;     215 // OC1B output: Discon.
;     216 // Noise Canceler: Off
;     217 // Input Capture on Falling Edge
;     218 // Timer 1 Overflow Interrupt: Off
;     219 // Input Capture Interrupt: Off
;     220 // Compare A Match Interrupt: Off
;     221 // Compare B Match Interrupt: Off
;     222 TCCR1A=0x00;
	OUT  0x2F,R30
;     223 TCCR1B=0x00;
	OUT  0x2E,R30
;     224 TCNT1H=0x00;
	OUT  0x2D,R30
;     225 TCNT1L=0x00;
	OUT  0x2C,R30
;     226 ICR1H=0x00;
	OUT  0x27,R30
;     227 ICR1L=0x00;
	OUT  0x26,R30
;     228 OCR1AH=0x00;
	OUT  0x2B,R30
;     229 OCR1AL=0x00;
	OUT  0x2A,R30
;     230 OCR1BH=0x00;
	OUT  0x29,R30
;     231 OCR1BL=0x00;
	OUT  0x28,R30
;     232 
;     233 // Timer/Counter 2 initialization
;     234 // Clock source: System Clock
;     235 // Clock value: Timer 2 Stopped
;     236 // Mode: Normal top=FFh
;     237 // OC2 output: Disconnected
;     238 ASSR=0x00;
	OUT  0x22,R30
;     239 TCCR2=0x00;
	OUT  0x25,R30
;     240 TCNT2=0x00;
	OUT  0x24,R30
;     241 OCR2=0x00;
	OUT  0x23,R30
;     242 
;     243 // External Interrupt(s) initialization
;     244 // INT0: Off
;     245 // INT1: Off
;     246 // INT2: Off
;     247 MCUCR=0x00;
	OUT  0x35,R30
;     248 MCUCSR=0x00;
	OUT  0x34,R30
;     249 
;     250 // Timer(s)/Counter(s) Interrupt(s) initialization
;     251 TIMSK=0x00;
	OUT  0x39,R30
;     252 
;     253 // USART initialization
;     254 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     255 // USART Receiver: On
;     256 // USART Transmitter: On
;     257 // USART Mode: Asynchronous
;     258 // USART Baud Rate: 19200
;     259 UCSRA=0x00;
	OUT  0xB,R30
;     260 UCSRB=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;     261 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     262 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     263 UBRRL=0x31;//0x26;
	LDI  R30,LOW(49)
	OUT  0x9,R30
;     264 
;     265 // Analog Comparator initialization
;     266 // Analog Comparator: Off
;     267 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     268 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     269 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     270 
;     271 // Global enable interrupts
;     272 #asm("sei")
	sei
;     273 
;     274 printf("OK BOUNTY\r\n");
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     275 
;     276 while (1)
_0x1B:
;     277       {
;     278       // Place your code here
;     279       //        
;     280       //       -
;     281       //      50   ,   
;     282 
;     283       if(keys0 == ~PINA){keys= ~PINA;}
	IN   R30,0x19
	COM  R30
	CP   R30,R11
	BRNE _0x1E
	IN   R30,0x19
	COM  R30
	MOV  R8,R30
;     284       keys0= ~PINA;
_0x1E:
	IN   R30,0x19
	COM  R30
	MOV  R11,R30
;     285 
;     286       if(encode0==PINC){encode=PINC;}
	IN   R30,0x13
	CP   R30,R13
	BRNE _0x1F
	IN   R10,19
;     287       encode0=PINC;
_0x1F:
	IN   R13,19
;     288 
;     289       //    ,   ,   
;     290       direction=0;
	LDI  R30,LOW(0)
	STS  _direction,R30
;     291       if((encode & 0x01) != (encodeOld & 0x01)){
	MOV  R30,R10
	ANDI R30,LOW(0x1)
	MOV  R26,R30
	MOV  R30,R12
	ANDI R30,LOW(0x1)
	CP   R30,R26
	BREQ _0x20
;     292         // 
;     293         direction |= 0x03;
	LDS  R30,_direction
	ORI  R30,LOW(0x3)
	STS  _direction,R30
;     294       }
;     295 
;     296       if((encode & 0x02) != (encodeOld & 0x02)){
_0x20:
	MOV  R30,R10
	ANDI R30,LOW(0x2)
	MOV  R26,R30
	MOV  R30,R12
	ANDI R30,LOW(0x2)
	CP   R30,R26
	BREQ _0x21
;     297         // 
;     298         direction |= 0x0c;
	LDS  R30,_direction
	ORI  R30,LOW(0xC)
	STS  _direction,R30
;     299 //printf("0x0c\r\n");
;     300       }
;     301 
;     302       if((encode & 0x04) != (encodeOld & 0x04)){
_0x21:
	MOV  R30,R10
	ANDI R30,LOW(0x4)
	MOV  R26,R30
	MOV  R30,R12
	ANDI R30,LOW(0x4)
	CP   R30,R26
	BREQ _0x22
;     303         // 
;     304         direction |= 0x30;
	LDS  R30,_direction
	ORI  R30,LOW(0x30)
	STS  _direction,R30
;     305       }
;     306       direction &= command;
_0x22:
	MOV  R30,R6
	LDS  R26,_direction
	AND  R30,R26
	STS  _direction,R30
;     307 //printf("E %i old %i D %i\r\n",(encode & 0x02), (encodeOld & 0x02), direction);
;     308       encodeOld = encode;
	MOV  R12,R10
;     309 
;     310 //printf("B command = %i mode=%i encode=%i\r\n", command,mode,encode);
;     311 
;     312         if(mode==0){
	LDS  R30,_mode
	CPI  R30,0
	BRNE _0x23
;     313                 command=getchar();
	CALL _getchar
	MOV  R6,R30
;     314                 //  
;     315 //PORTB = command;
;     316                 command-=0x31;// ,     0,       31 ("1")
	LDI  R30,LOW(49)
	SUB  R6,R30
;     317                 //  ,   mode=1
;     318                 if(validCommand(command)!=255){
	ST   -Y,R6
	CALL _validCommand
	CPI  R30,LOW(0xFF)
	BREQ _0x24
;     319 //putsf("valid ");
;     320                         mode=1;
	LDI  R30,LOW(1)
	STS  _mode,R30
;     321                 }
;     322         }
_0x24:
;     323 
;     324         if(mode==1){
_0x23:
	LDS  R26,_mode
	CPI  R26,LOW(0x1)
	BRNE _0x25
;     325 //putsf("mode=1 ");
;     326                 //    
;     327 //printf("C %i ",command);
;     328                 command = (keys & command) ^ command;
	MOV  R30,R6
	AND  R30,R8
	EOR  R6,R30
;     329 //printf("K %i C %i\r\n", keys, command);
;     330                 // engine   
;     331                 engine = (direction & command) ^ command;
	MOV  R30,R6
	LDS  R26,_direction
	AND  R30,R26
	EOR  R30,R6
	MOV  R9,R30
;     332 //printf("engine = (%i & %i) ^ %i = %i\r\n", direction,command,command, engine);
;     333 
;     334                 PORTB=engine;
	OUT  0x18,R9
;     335                 //   , 
;     336                 if((engine & 0x3f) == 0){
	MOV  R30,R9
	ANDI R30,LOW(0x3F)
	BRNE _0x26
;     337                         putchar1(command);
	ST   -Y,R6
	CALL _putchar1
;     338                         mode=0;
	LDI  R30,LOW(0)
	STS  _mode,R30
;     339                         encode0=0;
	CLR  R13
;     340                         encode=0;
	CLR  R10
;     341                         encodeOld=0;
	CLR  R12
;     342 //printf("command = %i mode=%i\r\n", command,mode);
;     343                 }
;     344         }
_0x26:
;     345 
;     346         delay_ms(50);//   
_0x25:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     347       };
	RJMP _0x1B
;     348 }
_0x27:
	RJMP _0x27

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x35
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x37
	__CPWRN 16,17,2
	BRLO _0x38
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x37:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x38:
	RJMP _0x39
_0x35:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0x39:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
_0x3A:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x3C
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x40
	CPI  R18,37
	BRNE _0x41
	LDI  R17,LOW(1)
	RJMP _0x42
_0x41:
	CALL SUBOPT_0x0
_0x42:
	RJMP _0x3F
_0x40:
	CPI  R30,LOW(0x1)
	BRNE _0x43
	CPI  R18,37
	BRNE _0x44
	CALL SUBOPT_0x0
	RJMP _0xE8
_0x44:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x45
	LDI  R16,LOW(1)
	RJMP _0x3F
_0x45:
	CPI  R18,43
	BRNE _0x46
	LDI  R20,LOW(43)
	RJMP _0x3F
_0x46:
	CPI  R18,32
	BRNE _0x47
	LDI  R20,LOW(32)
	RJMP _0x3F
_0x47:
	RJMP _0x48
_0x43:
	CPI  R30,LOW(0x2)
	BRNE _0x49
_0x48:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x4A
	ORI  R16,LOW(128)
	RJMP _0x3F
_0x4A:
	RJMP _0x4B
_0x49:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x3F
_0x4B:
	CPI  R18,48
	BRLO _0x4E
	CPI  R18,58
	BRLO _0x4F
_0x4E:
	RJMP _0x4D
_0x4F:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x3F
_0x4D:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x53
	CALL SUBOPT_0x1
	LD   R30,X
	CALL SUBOPT_0x2
	RJMP _0x54
_0x53:
	CPI  R30,LOW(0x73)
	BRNE _0x56
	CALL SUBOPT_0x1
	CALL SUBOPT_0x3
	CALL _strlen
	MOV  R17,R30
	RJMP _0x57
_0x56:
	CPI  R30,LOW(0x70)
	BRNE _0x59
	CALL SUBOPT_0x1
	CALL SUBOPT_0x3
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x57:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x5A
_0x59:
	CPI  R30,LOW(0x64)
	BREQ _0x5D
	CPI  R30,LOW(0x69)
	BRNE _0x5E
_0x5D:
	ORI  R16,LOW(4)
	RJMP _0x5F
_0x5E:
	CPI  R30,LOW(0x75)
	BRNE _0x60
_0x5F:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x61
_0x60:
	CPI  R30,LOW(0x58)
	BRNE _0x63
	ORI  R16,LOW(8)
	RJMP _0x64
_0x63:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x95
_0x64:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x61:
	SBRS R16,2
	RJMP _0x66
	CALL SUBOPT_0x1
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x67
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x67:
	CPI  R20,0
	BREQ _0x68
	SUBI R17,-LOW(1)
	RJMP _0x69
_0x68:
	ANDI R16,LOW(251)
_0x69:
	RJMP _0x6A
_0x66:
	CALL SUBOPT_0x1
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x6A:
_0x5A:
	SBRC R16,0
	RJMP _0x6B
_0x6C:
	CP   R17,R21
	BRSH _0x6E
	SBRS R16,7
	RJMP _0x6F
	SBRS R16,2
	RJMP _0x70
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x71
_0x70:
	LDI  R18,LOW(48)
_0x71:
	RJMP _0x72
_0x6F:
	LDI  R18,LOW(32)
_0x72:
	CALL SUBOPT_0x0
	SUBI R21,LOW(1)
	RJMP _0x6C
_0x6E:
_0x6B:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x73
_0x74:
	CPI  R19,0
	BREQ _0x76
	SBRS R16,3
	RJMP _0x77
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0xE9
_0x77:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xE9:
	ST   -Y,R30
	CALL SUBOPT_0x4
	CPI  R21,0
	BREQ _0x79
	SUBI R21,LOW(1)
_0x79:
	SUBI R19,LOW(1)
	RJMP _0x74
_0x76:
	RJMP _0x7A
_0x73:
_0x7C:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x7E:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x80
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x7E
_0x80:
	CPI  R18,58
	BRLO _0x81
	SBRS R16,3
	RJMP _0x82
	SUBI R18,-LOW(7)
	RJMP _0x83
_0x82:
	SUBI R18,-LOW(39)
_0x83:
_0x81:
	SBRC R16,4
	RJMP _0x85
	CPI  R18,49
	BRSH _0x87
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x86
_0x87:
	RJMP _0xEA
_0x86:
	CP   R21,R19
	BRLO _0x8B
	SBRS R16,0
	RJMP _0x8C
_0x8B:
	RJMP _0x8A
_0x8C:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x8D
	LDI  R18,LOW(48)
_0xEA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x8E
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x4
	CPI  R21,0
	BREQ _0x8F
	SUBI R21,LOW(1)
_0x8F:
_0x8E:
_0x8D:
_0x85:
	CALL SUBOPT_0x0
	CPI  R21,0
	BREQ _0x90
	SUBI R21,LOW(1)
_0x90:
_0x8A:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x7D
	RJMP _0x7C
_0x7D:
_0x7A:
	SBRS R16,0
	RJMP _0x91
_0x92:
	CPI  R21,0
	BREQ _0x94
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x2
	RJMP _0x92
_0x94:
_0x91:
_0x95:
_0x54:
_0xE8:
	LDI  R17,LOW(0)
_0x3F:
	RJMP _0x3A
_0x3C:
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G2
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_p_S47:
	.BYTE 0x2

	.CSEG

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x0:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xBB8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
